package net.t2code.t2codelib.BUNGEE.api.pluginMessaging.opSecurity;

import net.md_5.bungee.api.ProxyServer;
import net.md_5.bungee.api.connection.Server;
import net.md_5.bungee.api.event.PluginMessageEvent;
import net.md_5.bungee.api.plugin.Listener;
import net.md_5.bungee.event.EventHandler;
import net.t2code.t2codelib.util.T2C_Util;

import java.io.*;
import java.util.logging.Logger;

public class T2CB_API_OpSecurity implements Listener {

    @EventHandler
    public void onPluginmessage(PluginMessageEvent event) {
        if (event.getTag().equalsIgnoreCase(T2C_Util.getPluginChannel_OPSecurity())) {
            if (!(event.getSender() instanceof Server)) {
                ProxyServer.getInstance().getConsole().sendMessage(T2C_Util.getPrefix() +" [Security] §cBlocked unauthorized plugin message from a player ("+ event.getSender().toString() +")!");
                return;
            }
            event.setCancelled(true);
            DataInputStream stream = new DataInputStream(new ByteArrayInputStream(event.getData()));
            try {
                String channel = stream.readUTF();
                String mode = stream.readUTF();
                String information = stream.readUTF();
                if (channel.equals("T2Cconsole")) {
                    sendToSpigotPlayer(channel,mode,information);
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    private static void sendToSpigotPlayer(String channel,String mode,String information) {
        ByteArrayOutputStream stream = new ByteArrayOutputStream();
        DataOutputStream output = new DataOutputStream(stream);
        try {
            output.writeUTF(channel);
            output.writeUTF(mode);
            output.writeUTF(information);
        } catch (IOException e) {
            Logger.getLogger(e.getMessage());
        }
        ProxyServer.getInstance().getServers().values().stream().forEach((server) -> {
            server.sendData(T2C_Util.getPluginChannel_OPSecurity(), stream.toByteArray());
        });
    }
}
