// This class was created by JaTiTV.

package net.t2code.t2codelib.VELOCITY.api.pluginMessaging.opSecurity;

import com.velocitypowered.api.event.Subscribe;
import com.velocitypowered.api.event.connection.PluginMessageEvent;
import com.velocitypowered.api.proxy.ProxyServer;
import com.velocitypowered.api.proxy.ServerConnection;
import com.velocitypowered.api.proxy.server.RegisteredServer;
import net.kyori.adventure.text.Component;
import net.t2code.t2codelib.VELOCITY.system.T2CV_Main;
import net.t2code.t2codelib.util.T2C_Util;
import org.slf4j.Logger;

import java.io.*;

public class T2CV_API_OpSecurity {
    private static  ProxyServer server ;
    private static  Logger logger ;

    public T2CV_API_OpSecurity(ProxyServer server, Logger logger) {
        T2CV_API_OpSecurity.server = server;
        T2CV_API_OpSecurity.logger = logger;
        server.getChannelRegistrar().register(T2CV_Main.opsec);
    }

    @Subscribe
    public void onPluginmessage(PluginMessageEvent event) {
        if (event.getIdentifier() != T2CV_Main.opsec) {
            return;
        }

        if (!(event.getSource() instanceof ServerConnection)) {
            T2CV_Main.getLogger().info(T2C_Util.getPrefix() +" [Security] §cBlocked unauthorized plugin message from a player ({})!", event.getSource().toString());
            return;
        }

        DataInputStream stream = new DataInputStream(new ByteArrayInputStream(event.getData()));
        try {
            String channel = stream.readUTF();
            String mode = stream.readUTF();
            String information = stream.readUTF();
            if (channel.equals("T2Cconsole")) {
                sendToSpigotPlayer(channel,mode,information);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    private static void sendToSpigotPlayer(String channel,String mode,String information) {
        ByteArrayOutputStream stream = new ByteArrayOutputStream();
        DataOutputStream output = new DataOutputStream(stream);
        try {
            output.writeUTF(channel);
            output.writeUTF(mode);
            output.writeUTF(information);
        } catch (IOException e) {
            logger.error(e.getMessage());
        }
        for (RegisteredServer server : server.getAllServers()) {
            server.sendPluginMessage(T2CV_Main.opsec, stream.toByteArray());
        }
    }
}